/**
 * @file
 * Vue app for cart.
 */

(function ($) {
  "use strict";
  console.log('custom/syncart/favorite.js');

  Vue.component('favorite-field', {
    props: {
      pid: 0,
    },
    data() {
      return {
        productsLoaded: false,
        fav: false,
      }
    },
    methods: {
      addFav() {
        if (!this.fav) {
          this.fav = true;
          this.likeClicked = true;
          var favorites = this.$cookies.get('favorites');
          if (typeof(favorites) !== 'object' || favorites == null) {
            favorites = {};
          }
          favorites[this.pid] = true;
          this.$cookies.set('favorites', favorites, '30d');
          var favorites_amount = Object.keys(favorites).length;
          this.$root.$emit('update_favorite', favorites_amount);
        }
      },
      // Удалить из избранное.
      deleteFav() {
        if (this.fav) {
          this.fav = false;
          this.likeClicked = false;
          var favorites = this.$cookies.get('favorites');
          if (typeof(favorites) !== 'object' || favorites == null) {
            favorites = {};
          }
          delete favorites[this.pid];
          this.$cookies.set('favorites', favorites, '30d');
          var favorites_amount = Object.keys(favorites).length;
          this.$root.$emit('update_favorite', favorites_amount);
        }
      },
    },
    created() {
      this.productsLoaded = true;
      let favorites = this.$cookies.get('favorites');
      if (favorites !== null && typeof(favorites) == 'object' && favorites.hasOwnProperty(this.pid)) {
        this.fav = true;
      }
      if (localStorage.watched) {
        var array = localStorage.watched.split('|');
      }
      else {
        var array = [];
      }
      let index = array.indexOf(this.pid.toString());
      if (index === -1) {
        array.push(this.pid);
        localStorage.watched = array.join('|');
      }
    }
  });


})(this.jQuery);
